/*
 * IstreamWrapper.h
 *
 *  Created on: Mar 19, 2010
 *      Author: kohany
 */

#ifndef IOWRAPPER_H_
#define IOWRAPPER_H_

#include <fstream>
using namespace std;

class IstreamWrapper {
protected:
   istream* is;
   void close();
public:
   IstreamWrapper();
   IstreamWrapper(const char* fn);
   virtual ~IstreamWrapper();
   virtual void open(const char* fn);
   operator istream& ();
   istream& stream() {
      return *is;
   }
};

class IFstreamWrapper : public IstreamWrapper {
public:
   IFstreamWrapper(const char* fn);
   virtual ~IFstreamWrapper();
   virtual void open(const char* fn);
};

class OstreamWrapper {
   ostream* os;
   void close();
public:
   OstreamWrapper();
   OstreamWrapper(const char* fn);
   virtual ~OstreamWrapper();
   void open(const char* fn);
   operator ostream& ();
   ostream& stream() {
      return *os;
   }
};

#endif /* IOWRAPPER_H_ */
