/*
 * PairwiseAligner.h
 *
 *  Created on: Mar 11, 2010
 *      Author: kohany
 */

#ifndef PAIRWISEALIGNER_H_
#define PAIRWISEALIGNER_H_

#include "align2seq_monard.h"
#include "align2seq_swsse2.h"
#ifndef _OPEN_SOURCE_
#include "align2seq_pgswat.h"
#endif

#include "BioAlignment.h"

enum ALNALG {
   SWSSE2, PGSWAT, MONARDO
};

class PairwiseAligner {
   ALNALG alignmentMethod;
   int gapIni;
   int gapExt;
public:
   PairwiseAligner();
   virtual ~PairwiseAligner();
   void setGapIni(int gapIni) {
      PairwiseAligner::gapIni = gapIni;
   }
   int getGapIni() const {
      return PairwiseAligner::gapIni;
   }
   void setGapExt(int gapExt) {
      PairwiseAligner::gapExt = gapExt;
   }
   int getGapExt() const {
      return PairwiseAligner::gapExt;
   }
   void setAlignmentMethod(ALNALG method) {
      PairwiseAligner::alignmentMethod = method;
   }
   ALNALG getAlignmentMethod() const {
      return PairwiseAligner::alignmentMethod;
   }
   static void setAlignmentMatrix(const char* matfile);
   static void setAlignmentMatrix(const ScoreMatrix& mat);

   double align(BioAlignment& aln) const;
};

#endif /* PAIRWISEALIGNER_H_ */
